import struct
def sizeof(type):
  return struct.calcsize(type)

AFMT_AC3=0x00000400
AFMT_A_LAW=0x00000002
AFMT_IMA_ADPCM=0x00000004
AFMT_MPEG=0x00000200
AFMT_MU_LAW=0x00000001
AFMT_QUERY=0x00000000
AFMT_S16_BE=0x00000020
AFMT_S16_LE=0x00000010
AFMT_S16_NE=AFMT_S16_LE
AFMT_S8=0x00000040
AFMT_U16_BE=0x00000100
AFMT_U16_LE=0x00000080
AFMT_U8=0x00000008
APF_CPUINTENS=2
APF_NETWORK=1
APF_NORMAL=0
CPF_FIRST=0x0001
CPF_LAST=0x0002
CPF_NONE=0x0000
CTL_BALANCE=0x08
CTL_BANK_SELECT=0x00
CTL_BREATH=0x02
CTL_CELESTE_DEPTH=0x5e
CTL_CHORUS_DEPTH=0x5d
CTL_DAMPER_PEDAL=0x40
CTL_DATA_DECREMENT=0x61
CTL_DATA_ENTRY=0x06
CTL_DATA_INCREMENT=0x60
CTL_DETUNE_DEPTH=0x5e
CTL_EXPRESSION=0x0b
CTL_EXT_EFF_DEPTH=0x5b
CTL_FOOT=0x04
CTL_GENERAL_PURPOSE1=0x10
CTL_GENERAL_PURPOSE2=0x11
CTL_GENERAL_PURPOSE3=0x12
CTL_GENERAL_PURPOSE4=0x13
CTL_GENERAL_PURPOSE5=0x50
CTL_GENERAL_PURPOSE6=0x51
CTL_GENERAL_PURPOSE7=0x52
CTL_GENERAL_PURPOSE8=0x53
CTL_HOLD=0x40
CTL_HOLD2=0x45
CTL_MAIN_VOLUME=0x07
CTL_MODWHEEL=0x01
CTL_NONREG_PARM_NUM_LSB=0x62
CTL_NONREG_PARM_NUM_MSB=0x63
CTL_PAN=0x0a
CTL_PHASER_DEPTH=0x5f
CTL_PORTAMENTO=0x41
CTL_PORTAMENTO_TIME=0x05
CTL_REGIST_PARM_NUM_LSB=0x64
CTL_REGIST_PARM_NUM_MSB=0x65
CTL_SOFT_PEDAL=0x43
CTL_SOSTENUTO=0x42
CTL_SUSTAIN=0x40
CTL_TREMOLO_DEPTH=0x5c
CTRL_EXPRESSION=253
CTRL_MAIN_VOLUME=252
CTRL_PITCH_BENDER=255
CTRL_PITCH_BENDER_RANGE=254
DSP_BIND_CENTER_LFE=0x00000004
DSP_BIND_FRONT=0x00000001
DSP_BIND_HANDSET=0x00000008
DSP_BIND_I2S=0x00000080
DSP_BIND_MIC=0x00000010
DSP_BIND_MODEM1=0x00000020
DSP_BIND_MODEM2=0x00000040
DSP_BIND_QUERY=0x00000000
DSP_BIND_SPDIF=0x00000100
DSP_BIND_SURR=0x00000002
DSP_CAP_BATCH=0x00000400
DSP_CAP_BIND=0x00008000
DSP_CAP_COPROC=0x00000800
DSP_CAP_DUPLEX=0x00000100
DSP_CAP_MMAP=0x00002000
DSP_CAP_MULTI=0x00004000
DSP_CAP_REALTIME=0x00000200
DSP_CAP_REVISION=0x000000ff
DSP_CAP_TRIGGER=0x00001000
EV_CHN_COMMON=0x92
EV_CHN_VOICE=0x93
EV_SEQ_LOCAL=0x80
EV_SYSEX=0x94
EV_TIMING=0x81
def _PATCHKEY(id):
  return ( (id << 8 ) | 0xfd )
FM_PATCH=_PATCHKEY ( 0x01 )
FM_TYPE_ADLIB=0x00
FM_TYPE_OPL3=0x01
WAVE_PATCH=_PATCHKEY ( 0x04 )
GUS_PATCH=WAVE_PATCH
_IOC_SIZEBITS=14
_IOC_SIZEMASK=( (1 << _IOC_SIZEBITS ) - 1 )
_IOC_NRSHIFT=0
_IOC_NRBITS=8
_IOC_TYPESHIFT=( _IOC_NRSHIFT + _IOC_NRBITS )
_IOC_TYPEBITS=8
_IOC_SIZESHIFT=( _IOC_TYPESHIFT + _IOC_TYPEBITS )
IOCSIZE_MASK=( _IOC_SIZEMASK << _IOC_SIZESHIFT )
IOCSIZE_SHIFT=( _IOC_SIZESHIFT )
_IOC_WRITE=1
_IOC_DIRSHIFT=( _IOC_SIZESHIFT + _IOC_SIZEBITS )
IOC_IN=( _IOC_WRITE << _IOC_DIRSHIFT )
_IOC_READ=2
IOC_INOUT=( (_IOC_WRITE | _IOC_READ ) << _IOC_DIRSHIFT )
IOC_OUT=( _IOC_READ << _IOC_DIRSHIFT )
LOCL_STARTAUDIO=1
MAUI_PATCH=_PATCHKEY ( 0x06 )
MIDI_CAP_MPU401=1
MIDI_CHN_PRESSURE=0xD0
MIDI_CTL_CHANGE=0xB0
MIDI_KEY_PRESSURE=0xA0
MIDI_NOTEOFF=0x80
MIDI_NOTEON=0x90
MIDI_PGM_CHANGE=0xC0
MIDI_PITCH_BEND=0xE0
MIDI_SYSTEM_PREFIX=0xF0
MIDI_TYPE_MPU401=0x401
def _IOC(dir,type,nr,size):
  return ( ((dir ) << _IOC_DIRSHIFT ) | ( (type ) << _IOC_TYPESHIFT ) | ( (nr ) << _IOC_NRSHIFT ) | ( (size ) << _IOC_SIZESHIFT ) )
def _IOR(type,nr,size):
  return _IOC ( _IOC_READ , ( type ) , ( nr ) , sizeof ( size ) )
_SIOR=_IOR
def MIXER_READ(dev):
  return _SIOR ( ord('M') , dev , 'i' )
def _IOWR(type,nr,size):
  return _IOC ( _IOC_READ | _IOC_WRITE , ( type ) , ( nr ) , sizeof ( size ) )
_SIOWR=_IOWR
def MIXER_WRITE(dev):
  return _SIOWR ( ord('M') , dev , 'i' )
OPEN_SOUND_SYSTEM=None
OPL3_PATCH=_PATCHKEY ( 0x03 )
OSS_GETVERSION=_SIOR ( ord('M') , 118 , 'i' )
PCM_ENABLE_INPUT=0x00000001
PCM_ENABLE_OUTPUT=0x00000002
SAMPLE_TYPE_BASIC=0x10
SAMPLE_TYPE_GUS=SAMPLE_TYPE_BASIC
SAMPLE_TYPE_WAVEFRONT=0x11
SEQ_AFTERTOUCH=9
SEQ_BALANCE=11
#'if' undefined in '_SEQ_NEEDBUF'
#'_CHN_COMMON': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_BENDER': failed dependancy:'_CHN_COMMON'
#'if' undefined in '_SEQ_NEEDBUF'
#'SEQ_V2_X_CONTROL': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_BENDER_RANGE': failed dependancy:'SEQ_V2_X_CONTROL'
#'if' undefined in '_SEQ_NEEDBUF'
#'_CHN_COMMON': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_CHN_PRESSURE': failed dependancy:'_CHN_COMMON'
#'if' undefined in '_SEQ_NEEDBUF'
#'_TIMER_EVENT': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_CONTINUE_TIMER': failed dependancy:'_TIMER_EVENT'
#'if' undefined in '_SEQ_NEEDBUF'
#'_CHN_COMMON': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_CONTROL': failed dependancy:'_CHN_COMMON'
SEQ_CONTROLLER=10
#'extern' undefined in 'SEQ_USE_EXTBUF'
#'SEQ_DECLAREBUF': failed dependancy:'SEQ_USE_EXTBUF'
#'_seqbuf' undefined in 'SEQ_DEFINEBUF'
#'if' undefined in '_SEQ_NEEDBUF'
#'_TIMER_EVENT': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_DELTA_TIME': failed dependancy:'_TIMER_EVENT'
SEQ_DRUMOFF=7
SEQ_DRUMON=6
#'seqbuf_dump' undefined in 'SEQ_DUMPBUF'
TMR_ECHO=8
SEQ_ECHO=TMR_ECHO
#'if' undefined in '_SEQ_NEEDBUF'
#'_TIMER_EVENT': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_ECHO_BACK': failed dependancy:'_TIMER_EVENT'
#'if' undefined in '_SEQ_NEEDBUF'
#'_CHN_COMMON': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_CONTROL': failed dependancy:'_CHN_COMMON'
#'SEQ_EXPRESSION': failed dependancy:'SEQ_CONTROL'
SEQ_EXTENDED=0xff
SEQ_NOTEOFF=0
SEQ_FMNOTEOFF=SEQ_NOTEOFF
SEQ_NOTEON=1
SEQ_FMNOTEON=SEQ_NOTEON
SEQ_PGMCHANGE=3
SEQ_FMPGMCHANGE=SEQ_PGMCHANGE
SEQ_FULLSIZE=0xfd
#'if' undefined in '_SEQ_NEEDBUF'
#'_CHN_VOICE': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_KEY_PRESSURE': failed dependancy:'_CHN_VOICE'
def SEQ_LOAD_GMDRUM(dev,drum):
  return 
def SEQ_LOAD_GMINSTR(dev,instr):
  return 
#'if' undefined in '_SEQ_NEEDBUF'
#'_CHN_COMMON': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_CONTROL': failed dependancy:'_CHN_COMMON'
#'SEQ_MAIN_VOLUME': failed dependancy:'SEQ_CONTROL'
#'if' undefined in '_SEQ_NEEDBUF'
#'SEQ_MIDIOUT': failed dependancy:'_SEQ_NEEDBUF'
SEQ_MIDIPUTC=5
#'if' undefined in '_SEQ_NEEDBUF'
#'_CHN_COMMON': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_CONTROL': failed dependancy:'_CHN_COMMON'
#'SEQ_PANNING': failed dependancy:'SEQ_CONTROL'
#'if' undefined in '_SEQ_NEEDBUF'
#'_CHN_COMMON': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_PGM_CHANGE': failed dependancy:'_CHN_COMMON'
#'if' undefined in '_SEQ_NEEDBUF'
#'SEQ_V2_X_CONTROL': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_PITCHBEND': failed dependancy:'SEQ_V2_X_CONTROL'
#'if' undefined in '_SEQ_NEEDBUF'
#'_LOCAL_EVENT': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_PLAYAUDIO': failed dependancy:'_LOCAL_EVENT'
#'__foo_bar___' undefined in 'SEQ_PM_DEFINES'
SEQ_PRIVATE=0xfe
#'if' undefined in '_SEQ_NEEDBUF'
#'_CHN_COMMON': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_PGM_CHANGE': failed dependancy:'_CHN_COMMON'
#'SEQ_SET_PATCH': failed dependancy:'SEQ_PGM_CHANGE'
#'if' undefined in '_SEQ_NEEDBUF'
#'_TIMER_EVENT': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_SET_TEMPO': failed dependancy:'_TIMER_EVENT'
#'if' undefined in '_SEQ_NEEDBUF'
#'_TIMER_EVENT': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_SONGPOS': failed dependancy:'_TIMER_EVENT'
#'if' undefined in '_SEQ_NEEDBUF'
#'_CHN_VOICE': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_START_NOTE': failed dependancy:'_CHN_VOICE'
#'if' undefined in '_SEQ_NEEDBUF'
#'_TIMER_EVENT': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_START_TIMER': failed dependancy:'_TIMER_EVENT'
#'if' undefined in '_SEQ_NEEDBUF'
#'_CHN_VOICE': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_STOP_NOTE': failed dependancy:'_CHN_VOICE'
#'if' undefined in '_SEQ_NEEDBUF'
#'_TIMER_EVENT': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_STOP_TIMER': failed dependancy:'_TIMER_EVENT'
TMR_START=4
SEQ_SYNCTIMER=TMR_START
#'ii' undefined in 'SEQ_SYSEX'
#'if' undefined in '_SEQ_NEEDBUF'
#'_TIMER_EVENT': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_TIME_SIGNATURE': failed dependancy:'_TIMER_EVENT'
#'extern' undefined in 'SEQ_USE_EXTBUF'
#'if' undefined in '_SEQ_NEEDBUF'
#'SEQ_V2_X_CONTROL': failed dependancy:'_SEQ_NEEDBUF'
SEQ_VOLMODE=12
#'if' undefined in '_SEQ_NEEDBUF'
#'SEQ_VOLUME_MODE': failed dependancy:'_SEQ_NEEDBUF'
TMR_WAIT_ABS=2
SEQ_WAIT=TMR_WAIT_ABS
#'if' undefined in '_SEQ_NEEDBUF'
#'_TIMER_EVENT': failed dependancy:'_SEQ_NEEDBUF'
#'SEQ_WAIT_TIME': failed dependancy:'_TIMER_EVENT'
#'if' undefined in 'SEQ_WRPATCH'
#'SEQ_DUMPBUF(' undefined in 'SEQ_WRPATCH2'
#'IOCPARM_MASK' undefined in 'SIOCPARM_MASK'
SIOC_IN=IOC_IN
SIOC_INOUT=IOC_INOUT
SIOC_OUT=IOC_OUT
#'IOC_VOID' undefined in 'SIOC_VOID'
SNDCARD_ADLIB=1
SNDCARD_CS4232=21
SNDCARD_CS4232_MPU=22
SNDCARD_GUS=4
SNDCARD_GUS16=9
SNDCARD_GUSPNP=25
SNDCARD_MAD16=19
SNDCARD_MAD16_MPU=20
SNDCARD_MAUI=23
SNDCARD_MPU401=5
SNDCARD_MSS=10
SNDCARD_PAS=3
SNDCARD_PSEUDO_MSS=24
SNDCARD_PSS=11
SNDCARD_PSS_MPU=13
SNDCARD_PSS_MSS=14
SNDCARD_SB=2
SNDCARD_SB16=6
SNDCARD_SB16MIDI=7
SNDCARD_SSCAPE=12
SNDCARD_SSCAPE_MSS=15
SNDCARD_TRXPRO=16
SNDCARD_TRXPRO_MPU=18
SNDCARD_TRXPRO_SB=17
SNDCARD_UART401=26
SNDCARD_UART6850=8
#'copr_debug_buf' undefined in 'SNDCTL_COPR_HALT'
#'copr_buffer' undefined in 'SNDCTL_COPR_LOAD'
#'copr_debug_buf' undefined in 'SNDCTL_COPR_RCODE'
#'copr_msg' undefined in 'SNDCTL_COPR_RCVMSG'
#'copr_debug_buf' undefined in 'SNDCTL_COPR_RDATA'
_IOC_NONE=0
def _IO(type,nr):
  return _IOC ( _IOC_NONE , ( type ) , ( nr ) , 0 )
_SIO=_IO
SNDCTL_COPR_RESET=_SIO ( ord('C') , 0 )
#'copr_debug_buf' undefined in 'SNDCTL_COPR_RUN'
#'copr_msg' undefined in 'SNDCTL_COPR_SENDMSG'
def _IOW(type,nr,size):
  return _IOC ( _IOC_WRITE , ( type ) , ( nr ) , sizeof ( size ) )
_SIOW=_IOW
#'copr_debug_buf' undefined in 'SNDCTL_COPR_WCODE'
#'copr_debug_buf' undefined in 'SNDCTL_COPR_WDATA'
SNDCTL_DSP_BIND_CHANNEL=_SIOWR ( ord('P') , 65 , 'i' )
SNDCTL_DSP_CHANNELS=_SIOWR ( ord('P') , 6 , 'i' )
SNDCTL_DSP_GETBLKSIZE=_SIOWR ( ord('P') , 4 , 'i' )
SNDCTL_DSP_GETCAPS=_SIOR ( ord('P') , 15 , 'i' )
SNDCTL_DSP_GETCHANNELMASK=_SIOWR ( ord('P') , 64 , 'i' )
SNDCTL_DSP_GETFMTS=_SIOR ( ord('P') , 11 , 'i' )
#'count_info' undefined in 'SNDCTL_DSP_GETIPTR'
#'audio_buf_info' undefined in 'SNDCTL_DSP_GETISPACE'
SNDCTL_DSP_GETODELAY=_SIOR ( ord('P') , 23 , 'i' )
#'count_info' undefined in 'SNDCTL_DSP_GETOPTR'
#'audio_buf_info' undefined in 'SNDCTL_DSP_GETOSPACE'
SNDCTL_DSP_GETSPDIF=_SIOR ( ord('P') , 67 , 'i' )
SNDCTL_DSP_GETTRIGGER=_SIOR ( ord('P') , 16 , 'i' )
#'buffmem_desc' undefined in 'SNDCTL_DSP_MAPINBUF'
#'buffmem_desc' undefined in 'SNDCTL_DSP_MAPOUTBUF'
SNDCTL_DSP_NONBLOCK=_SIO ( ord('P') , 14 )
SNDCTL_DSP_POST=_SIO ( ord('P') , 8 )
SNDCTL_DSP_PROFILE=_SIOW ( ord('P') , 23 , 'i' )
SNDCTL_DSP_RESET=_SIO ( ord('P') , 0 )
SNDCTL_DSP_SETFMT=_SIOWR ( ord('P') , 5 , 'i' )
SNDCTL_DSP_SAMPLESIZE=SNDCTL_DSP_SETFMT
SNDCTL_DSP_SETDUPLEX=_SIO ( ord('P') , 22 )
SNDCTL_DSP_SETFRAGMENT=_SIOWR ( ord('P') , 10 , 'i' )
SNDCTL_DSP_SETSPDIF=_SIOW ( ord('P') , 66 , 'i' )
SNDCTL_DSP_SETSYNCRO=_SIO ( ord('P') , 21 )
SNDCTL_DSP_SETTRIGGER=_SIOW ( ord('P') , 16 , 'i' )
SNDCTL_DSP_SPEED=_SIOWR ( ord('P') , 2 , 'i' )
SNDCTL_DSP_STEREO=_SIOWR ( ord('P') , 3 , 'i' )
SNDCTL_DSP_SUBDIVIDE=_SIOWR ( ord('P') , 9 , 'i' )
SNDCTL_DSP_SYNC=_SIO ( ord('P') , 1 )
SNDCTL_FM_4OP_ENABLE=_SIOW ( ord('Q') , 15 , 'i' )
#'struct' undefined in 'SNDCTL_FM_LOAD_INSTR'
#'struct' undefined in 'SNDCTL_MIDI_INFO'
#'mpu_command_rec' undefined in 'SNDCTL_MIDI_MPUCMD'
SNDCTL_MIDI_MPUMODE=_SIOWR ( ord('m') , 1 , 'i' )
SNDCTL_MIDI_PRETIME=_SIOWR ( ord('m') , 0 , 'i' )
SNDCTL_SEQ_CTRLRATE=_SIOWR ( ord('Q') , 3 , 'i' )
SNDCTL_SEQ_GETINCOUNT=_SIOR ( ord('Q') , 5 , 'i' )
SNDCTL_SEQ_GETOUTCOUNT=_SIOR ( ord('Q') , 4 , 'i' )
SNDCTL_SEQ_GETTIME=_SIOR ( ord('Q') , 19 , 'i' )
SNDCTL_SEQ_NRMIDIS=_SIOR ( ord('Q') , 11 , 'i' )
SNDCTL_SEQ_NRSYNTHS=_SIOR ( ord('Q') , 10 , 'i' )
#'struct' undefined in 'SNDCTL_SEQ_OUTOFBAND'
SNDCTL_SEQ_PANIC=_SIO ( ord('Q') , 17 )
SNDCTL_SEQ_PERCMODE=_SIOW ( ord('Q') , 6 , 'i' )
SNDCTL_SEQ_RESET=_SIO ( ord('Q') , 0 )
SNDCTL_SEQ_RESETSAMPLES=_SIOW ( ord('Q') , 9 , 'i' )
SNDCTL_SEQ_SYNC=_SIO ( ord('Q') , 1 )
SNDCTL_SEQ_TESTMIDI=_SIOW ( ord('Q') , 8 , 'i' )
SNDCTL_SEQ_THRESHOLD=_SIOW ( ord('Q') , 13 , 'i' )
#'struct' undefined in 'SNDCTL_SYNTH_CONTROL'
#'struct' undefined in 'SNDCTL_SYNTH_ID'
#'struct' undefined in 'SNDCTL_SYNTH_INFO'
SNDCTL_SYNTH_MEMAVL=_SIOWR ( ord('Q') , 14 , 'i' )
#'struct' undefined in 'SNDCTL_SYNTH_REMOVESAMPLE'
SNDCTL_TMR_CONTINUE=_SIO ( ord('T') , 4 )
SNDCTL_TMR_METRONOME=_SIOW ( ord('T') , 7 , 'i' )
SNDCTL_TMR_SELECT=_SIOW ( ord('T') , 8 , 'i' )
SNDCTL_TMR_SOURCE=_SIOWR ( ord('T') , 6 , 'i' )
SNDCTL_TMR_START=_SIO ( ord('T') , 2 )
SNDCTL_TMR_STOP=_SIO ( ord('T') , 3 )
SNDCTL_TMR_TEMPO=_SIOWR ( ord('T') , 5 , 'i' )
SNDCTL_TMR_TIMEBASE=_SIOWR ( ord('T') , 1 , 'i' )
SOUNDCARD_H=None
SOUND_CAP_EXCL_INPUT=0x00000001
SOUND_DEVICE_LABELS=[ "Vol " , "Bass " , "Trebl" , "Synth" , "Pcm " , "Spkr " , "Line " , "Mic " , "CD " , "Mix " , "Pcm2 " , "Rec " , "IGain" , "OGain" , "Line1" , "Line2" , "Line3" , "Digital1" , "Digital2" , "Digital3" , "PhoneIn" , "PhoneOut" , "Video" , "Radio" , "Monitor" ]
SOUND_DEVICE_NAMES=[ "vol" , "bass" , "treble" , "synth" , "pcm" , "speaker" , "line" , "mic" , "cd" , "mix" , "pcm2" , "rec" , "igain" , "ogain" , "line1" , "line2" , "line3" , "dig1" , "dig2" , "dig3" , "phin" , "phout" , "video" , "radio" , "monitor" ]
SOUND_MIXER_ALTPCM=10
SOUND_MASK_ALTPCM=( 1 << SOUND_MIXER_ALTPCM )
SOUND_MIXER_BASS=1
SOUND_MASK_BASS=( 1 << SOUND_MIXER_BASS )
SOUND_MIXER_CD=8
SOUND_MASK_CD=( 1 << SOUND_MIXER_CD )
SOUND_MIXER_DIGITAL1=17
SOUND_MASK_DIGITAL1=( 1 << SOUND_MIXER_DIGITAL1 )
SOUND_MIXER_DIGITAL2=18
SOUND_MASK_DIGITAL2=( 1 << SOUND_MIXER_DIGITAL2 )
SOUND_MIXER_DIGITAL3=19
SOUND_MASK_DIGITAL3=( 1 << SOUND_MIXER_DIGITAL3 )
SOUND_MIXER_NONE=31
SOUND_MIXER_ENHANCE=SOUND_MIXER_NONE
SOUND_MASK_ENHANCE=( 1 << SOUND_MIXER_ENHANCE )
SOUND_MIXER_IGAIN=12
SOUND_MASK_IGAIN=( 1 << SOUND_MIXER_IGAIN )
SOUND_MIXER_IMIX=9
SOUND_MASK_IMIX=( 1 << SOUND_MIXER_IMIX )
SOUND_MIXER_LINE=6
SOUND_MASK_LINE=( 1 << SOUND_MIXER_LINE )
SOUND_MIXER_LINE1=14
SOUND_MASK_LINE1=( 1 << SOUND_MIXER_LINE1 )
SOUND_MIXER_LINE2=15
SOUND_MASK_LINE2=( 1 << SOUND_MIXER_LINE2 )
SOUND_MIXER_LINE3=16
SOUND_MASK_LINE3=( 1 << SOUND_MIXER_LINE3 )
SOUND_MIXER_LOUD=SOUND_MIXER_NONE
SOUND_MASK_LOUD=( 1 << SOUND_MIXER_LOUD )
SOUND_MIXER_MIC=7
SOUND_MASK_MIC=( 1 << SOUND_MIXER_MIC )
SOUND_MIXER_MONITOR=24
SOUND_MASK_MONITOR=( 1 << SOUND_MIXER_MONITOR )
SOUND_MIXER_MUTE=SOUND_MIXER_NONE
SOUND_MASK_MUTE=( 1 << SOUND_MIXER_MUTE )
SOUND_MIXER_OGAIN=13
SOUND_MASK_OGAIN=( 1 << SOUND_MIXER_OGAIN )
SOUND_MIXER_PCM=4
SOUND_MASK_PCM=( 1 << SOUND_MIXER_PCM )
SOUND_MIXER_PHONEIN=20
SOUND_MASK_PHONEIN=( 1 << SOUND_MIXER_PHONEIN )
SOUND_MIXER_PHONEOUT=21
SOUND_MASK_PHONEOUT=( 1 << SOUND_MIXER_PHONEOUT )
SOUND_MIXER_RADIO=23
SOUND_MASK_RADIO=( 1 << SOUND_MIXER_RADIO )
SOUND_MIXER_RECLEV=11
SOUND_MASK_RECLEV=( 1 << SOUND_MIXER_RECLEV )
SOUND_MIXER_SPEAKER=5
SOUND_MASK_SPEAKER=( 1 << SOUND_MIXER_SPEAKER )
SOUND_MIXER_SYNTH=3
SOUND_MASK_SYNTH=( 1 << SOUND_MIXER_SYNTH )
SOUND_MIXER_TREBLE=2
SOUND_MASK_TREBLE=( 1 << SOUND_MIXER_TREBLE )
SOUND_MIXER_VIDEO=22
SOUND_MASK_VIDEO=( 1 << SOUND_MIXER_VIDEO )
SOUND_MIXER_VOLUME=0
SOUND_MASK_VOLUME=( 1 << SOUND_MIXER_VOLUME )
SOUND_MIXER_3DSE=_SIOWR ( ord('M') , 104 , 'i' )
#'mixer_record' undefined in 'SOUND_MIXER_ACCESS'
SOUND_MIXER_AGC=_SIOWR ( ord('M') , 103 , 'i' )
SOUND_MIXER_CAPS=0xfc
SOUND_MIXER_DEVMASK=0xfe
#'mixer_vol_table' undefined in 'SOUND_MIXER_GETLEVELS'
#'mixer_info' undefined in 'SOUND_MIXER_INFO'
SOUND_MIXER_NRDEVICES=25
SOUND_MIXER_OUTMASK=0xf9
SOUND_MIXER_OUTSRC=0xfa
SOUND_MIXER_PRIVATE1=_SIOWR ( ord('M') , 111 , 'i' )
SOUND_MIXER_PRIVATE2=_SIOWR ( ord('M') , 112 , 'i' )
SOUND_MIXER_PRIVATE3=_SIOWR ( ord('M') , 113 , 'i' )
SOUND_MIXER_PRIVATE4=_SIOWR ( ord('M') , 114 , 'i' )
SOUND_MIXER_PRIVATE5=_SIOWR ( ord('M') , 115 , 'i' )
SOUND_MIXER_READ_ALTPCM=MIXER_READ ( SOUND_MIXER_ALTPCM )
SOUND_MIXER_READ_BASS=MIXER_READ ( SOUND_MIXER_BASS )
SOUND_MIXER_READ_CAPS=MIXER_READ ( SOUND_MIXER_CAPS )
SOUND_MIXER_READ_CD=MIXER_READ ( SOUND_MIXER_CD )
SOUND_MIXER_READ_DEVMASK=MIXER_READ ( SOUND_MIXER_DEVMASK )
SOUND_MIXER_READ_ENHANCE=MIXER_READ ( SOUND_MIXER_ENHANCE )
SOUND_MIXER_READ_IGAIN=MIXER_READ ( SOUND_MIXER_IGAIN )
SOUND_MIXER_READ_IMIX=MIXER_READ ( SOUND_MIXER_IMIX )
SOUND_MIXER_READ_LINE=MIXER_READ ( SOUND_MIXER_LINE )
SOUND_MIXER_READ_LINE1=MIXER_READ ( SOUND_MIXER_LINE1 )
SOUND_MIXER_READ_LINE2=MIXER_READ ( SOUND_MIXER_LINE2 )
SOUND_MIXER_READ_LINE3=MIXER_READ ( SOUND_MIXER_LINE3 )
SOUND_MIXER_READ_LOUD=MIXER_READ ( SOUND_MIXER_LOUD )
SOUND_MIXER_READ_MIC=MIXER_READ ( SOUND_MIXER_MIC )
SOUND_MIXER_READ_MUTE=MIXER_READ ( SOUND_MIXER_MUTE )
SOUND_MIXER_READ_OGAIN=MIXER_READ ( SOUND_MIXER_OGAIN )
SOUND_MIXER_READ_PCM=MIXER_READ ( SOUND_MIXER_PCM )
SOUND_MIXER_READ_RECLEV=MIXER_READ ( SOUND_MIXER_RECLEV )
SOUND_MIXER_RECMASK=0xfd
SOUND_MIXER_READ_RECMASK=MIXER_READ ( SOUND_MIXER_RECMASK )
SOUND_MIXER_RECSRC=0xff
SOUND_MIXER_READ_RECSRC=MIXER_READ ( SOUND_MIXER_RECSRC )
SOUND_MIXER_READ_SPEAKER=MIXER_READ ( SOUND_MIXER_SPEAKER )
SOUND_MIXER_STEREODEVS=0xfb
SOUND_MIXER_READ_STEREODEVS=MIXER_READ ( SOUND_MIXER_STEREODEVS )
SOUND_MIXER_READ_SYNTH=MIXER_READ ( SOUND_MIXER_SYNTH )
SOUND_MIXER_READ_TREBLE=MIXER_READ ( SOUND_MIXER_TREBLE )
SOUND_MIXER_READ_VOLUME=MIXER_READ ( SOUND_MIXER_VOLUME )
#'mixer_vol_table' undefined in 'SOUND_MIXER_SETLEVELS'
SOUND_MIXER_WRITE_ALTPCM=MIXER_WRITE ( SOUND_MIXER_ALTPCM )
SOUND_MIXER_WRITE_BASS=MIXER_WRITE ( SOUND_MIXER_BASS )
SOUND_MIXER_WRITE_CD=MIXER_WRITE ( SOUND_MIXER_CD )
SOUND_MIXER_WRITE_ENHANCE=MIXER_WRITE ( SOUND_MIXER_ENHANCE )
SOUND_MIXER_WRITE_IGAIN=MIXER_WRITE ( SOUND_MIXER_IGAIN )
SOUND_MIXER_WRITE_IMIX=MIXER_WRITE ( SOUND_MIXER_IMIX )
SOUND_MIXER_WRITE_LINE=MIXER_WRITE ( SOUND_MIXER_LINE )
SOUND_MIXER_WRITE_LINE1=MIXER_WRITE ( SOUND_MIXER_LINE1 )
SOUND_MIXER_WRITE_LINE2=MIXER_WRITE ( SOUND_MIXER_LINE2 )
SOUND_MIXER_WRITE_LINE3=MIXER_WRITE ( SOUND_MIXER_LINE3 )
SOUND_MIXER_WRITE_LOUD=MIXER_WRITE ( SOUND_MIXER_LOUD )
SOUND_MIXER_WRITE_MIC=MIXER_WRITE ( SOUND_MIXER_MIC )
SOUND_MIXER_WRITE_MUTE=MIXER_WRITE ( SOUND_MIXER_MUTE )
SOUND_MIXER_WRITE_OGAIN=MIXER_WRITE ( SOUND_MIXER_OGAIN )
SOUND_MIXER_WRITE_PCM=MIXER_WRITE ( SOUND_MIXER_PCM )
SOUND_MIXER_WRITE_RECLEV=MIXER_WRITE ( SOUND_MIXER_RECLEV )
SOUND_MIXER_WRITE_RECSRC=MIXER_WRITE ( SOUND_MIXER_RECSRC )
SOUND_MIXER_WRITE_SPEAKER=MIXER_WRITE ( SOUND_MIXER_SPEAKER )
SOUND_MIXER_WRITE_SYNTH=MIXER_WRITE ( SOUND_MIXER_SYNTH )
SOUND_MIXER_WRITE_TREBLE=MIXER_WRITE ( SOUND_MIXER_TREBLE )
SOUND_MIXER_WRITE_VOLUME=MIXER_WRITE ( SOUND_MIXER_VOLUME )
#'_old_mixer_info' undefined in 'SOUND_OLD_MIXER_INFO'
SOUND_ONOFF_MAX=30
SOUND_ONOFF_MIN=28
SOUND_PCM_GETCAPS=SNDCTL_DSP_GETCAPS
SOUND_PCM_GETFMTS=SNDCTL_DSP_GETFMTS
#'count_info' undefined in 'SNDCTL_DSP_GETIPTR'
#'SOUND_PCM_GETIPTR': failed dependancy:'SNDCTL_DSP_GETIPTR'
#'audio_buf_info' undefined in 'SNDCTL_DSP_GETISPACE'
#'SOUND_PCM_GETISPACE': failed dependancy:'SNDCTL_DSP_GETISPACE'
#'count_info' undefined in 'SNDCTL_DSP_GETOPTR'
#'SOUND_PCM_GETOPTR': failed dependancy:'SNDCTL_DSP_GETOPTR'
#'audio_buf_info' undefined in 'SNDCTL_DSP_GETOSPACE'
#'SOUND_PCM_GETOSPACE': failed dependancy:'SNDCTL_DSP_GETOSPACE'
SOUND_PCM_GETTRIGGER=SNDCTL_DSP_GETTRIGGER
#'buffmem_desc' undefined in 'SNDCTL_DSP_MAPINBUF'
#'SOUND_PCM_MAPINBUF': failed dependancy:'SNDCTL_DSP_MAPINBUF'
#'buffmem_desc' undefined in 'SNDCTL_DSP_MAPOUTBUF'
#'SOUND_PCM_MAPOUTBUF': failed dependancy:'SNDCTL_DSP_MAPOUTBUF'
SOUND_PCM_NONBLOCK=SNDCTL_DSP_NONBLOCK
SOUND_PCM_POST=SNDCTL_DSP_POST
SOUND_PCM_READ_BITS=_SIOR ( ord('P') , 5 , 'i' )
SOUND_PCM_READ_CHANNELS=_SIOR ( ord('P') , 6 , 'i' )
SOUND_PCM_READ_FILTER=_SIOR ( ord('P') , 7 , 'i' )
SOUND_PCM_READ_RATE=_SIOR ( ord('P') , 2 , 'i' )
SOUND_PCM_RESET=SNDCTL_DSP_RESET
SOUND_PCM_SETFMT=SNDCTL_DSP_SETFMT
SOUND_PCM_SETFRAGMENT=SNDCTL_DSP_SETFRAGMENT
SOUND_PCM_SETSYNCRO=SNDCTL_DSP_SETSYNCRO
SOUND_PCM_SETTRIGGER=SNDCTL_DSP_SETTRIGGER
SOUND_PCM_SUBDIVIDE=SNDCTL_DSP_SUBDIVIDE
SOUND_PCM_SYNC=SNDCTL_DSP_SYNC
SOUND_PCM_WRITE_BITS=SNDCTL_DSP_SETFMT
SOUND_PCM_WRITE_CHANNELS=SNDCTL_DSP_CHANNELS
SOUND_PCM_WRITE_FILTER=_SIOWR ( ord('P') , 7 , 'i' )
SOUND_PCM_WRITE_RATE=SNDCTL_DSP_SPEED
SOUND_VERSION=0x030802
SPDIF_CC=0x07f0
SPDIF_COPY=0x0004
SPDIF_DRS=0x4000
SPDIF_L=0x0800
SPDIF_N_AUD=0x0002
SPDIF_PRE=0x0008
SPDIF_PRO=0x0001
SPDIF_V=0x8000
SYNTH_CAP_INPUT=0x00000004
SYNTH_CAP_OPL3=0x00000002
SYNTH_CAP_PERCMODE=0x00000001
SYNTH_TYPE_FM=0
SYNTH_TYPE_MIDI=2
SYNTH_TYPE_SAMPLE=1
SYSEX_PATCH=_PATCHKEY ( 0x05 )
TMR_CLOCK=9
TMR_CONTINUE=5
TMR_EXTERNAL=0x00000002
TMR_INTERNAL=0x00000001
TMR_MODE_CLS=0x00000040
TMR_MODE_FSK=0x00000020
TMR_MODE_MIDI=0x00000010
TMR_MODE_SMPTE=0x00000080
TMR_SPP=10
TMR_STOP=3
TMR_TEMPO=6
TMR_TIMESIG=11
TMR_WAIT_REL=1
VOL_METHOD_ADAGIO=1
VOL_METHOD_LINEAR=2
WAVEFRONT_PATCH=_PATCHKEY ( 0x06 )
WAVE_16_BITS=0x01
WAVE_BIDIR_LOOP=0x08
WAVE_ENVELOPES=0x40
WAVE_FAST_RELEASE=0x80
WAVE_FRACTIONS=0x00080000
WAVE_LOOPING=0x04
WAVE_LOOP_BACK=0x10
WAVE_MULAW=0x20000000
WAVE_ROM=0x40000000
WAVE_SCALE=0x00040000
WAVE_SUSTAIN_ON=0x20
WAVE_TREMOLO=0x00020000
WAVE_UNSIGNED=0x02
WAVE_VIBRATO=0x00010000
_ASMI386_IOCTL_H=None
#'if' undefined in '_SEQ_NEEDBUF'
#'_CHN_COMMON': failed dependancy:'_SEQ_NEEDBUF'
#'if' undefined in '_SEQ_NEEDBUF'
#'_CHN_VOICE': failed dependancy:'_SEQ_NEEDBUF'
_IOC_DIRBITS=2
_IOC_DIRMASK=( (1 << _IOC_DIRBITS ) - 1 )
def _IOC_DIR(nr):
  return ( ((nr ) >> _IOC_DIRSHIFT ) & _IOC_DIRMASK )
_IOC_NRMASK=( (1 << _IOC_NRBITS ) - 1 )
def _IOC_NR(nr):
  return ( ((nr ) >> _IOC_NRSHIFT ) & _IOC_NRMASK )
def _IOC_SIZE(nr):
  return ( ((nr ) >> _IOC_SIZESHIFT ) & _IOC_SIZEMASK )
_IOC_TYPEMASK=( (1 << _IOC_TYPEBITS ) - 1 )
def _IOC_TYPE(nr):
  return ( ((nr ) >> _IOC_TYPESHIFT ) & _IOC_TYPEMASK )
_LINUX_IOCTL_H=None
#'if' undefined in '_SEQ_NEEDBUF'
#'_LOCAL_EVENT': failed dependancy:'_SEQ_NEEDBUF'
#'_seqbufptr' undefined in '_SEQ_ADVBUF'
#'if' undefined in '_SEQ_NEEDBUF'
_SIOC_DIR=_IOC_DIR
_SIOC_NONE=_IOC_NONE
_SIOC_READ=_IOC_READ
_SIOC_SIZE=_IOC_SIZE
_SIOC_WRITE=_IOC_WRITE
#'if' undefined in '_SEQ_NEEDBUF'
#'_TIMER_EVENT': failed dependancy:'_SEQ_NEEDBUF'
__ELF__=1
__HAVE_BUILTIN_SETJMP__=1
__NO_INLINE__=1
__PTRDIFF_TYPE__='i'
__REGISTER_PREFIX__=None
__SIZE_TYPE__='I'
__STDC_HOSTED__=1
__STDC__=1
__USER_LABEL_PREFIX__=None
#'Red' undefined in '__VERSION__'
__WCHAR_TYPE__='l' 'i'
__WINT_TYPE__='I'
__gnu_linux__=1
__i386=1
__i386__=1
__linux=1
__linux__=1
__tune_i386__=1
__unix=1
__unix__=1
i386=1
linux=1
unix=1
